var cqrPageSelection = "";
var cqrPageURL = "";
var cqrPageHost = "";
var cqrLinkURL = "";
var cqrImgName = "";
var cqrImgURL = "";
var cqrPageTitle = "";

var cqrAction = "";
var cqrActionPrompt = "";
var cqrConfigLastWillId = "";
var cqrConfigLastWillCtrl = false;
var cqrTabRef = "";
var cqrWndRef = "";
if (cqrMailFlag){
    var browser = getMessageBrowser();
}else{
    var browser = getBrowser();
}
//Inits
conQueryInit();

function conQueryInit(){
  prfs_LoadMain();
  lastDirState = rdir(cqrPlugsDir);
  srcDirChanged();
  plg_QuickLoadAll();
}

//Tools menu handler
function HandleToolsMenu(event){
try{
  if (event.target.childNodes[0] && 
      (event.target.childNodes[0].id == "menu_ToolsPopup" || 
       event.target.childNodes[0].id == "taskPopup")){
    var cqr_cfg = window.document.getElementById('cq-cfg-menu');
    //This will require restarting, i know, but perfomance is important :)
    //cqrHideFromTools = prfs_ReadItem("Main.HideFromTools");
    if (cqr_cfg) cqr_cfg.hidden = cqrHideFromTools;
  }
}catch(err){cqerr(err, "HandleToolsMenu sub")}
}

/// HotMenu. Many thanks to Henrik Gulbrandsen for developing this!
function RegisterContextMenuListener(){
  browser.addEventListener("contextmenu", HandleContextMenu, true);
}

function HandleInsertedNode(event){
//dump(event.target.id + "\n");
// somehow this sub breaks up the top menu ("File", "Edit" e.t.c) of Mozilla 1.7a, bild 2004010508
// ...and somehow HotMenu works without this :))
//  if (event.target.id == "content"){
//    RegisterContextMenuListener();
//  } 
}

document.addEventListener("DOMNodeInserted", HandleInsertedNode, false);
document.addEventListener("DOMMenuItemActive", HandleToolsMenu, true);
RegisterContextMenuListener();

function HandleContextMenu(event){
  cqrLinkURL = findParentNode(event.originalTarget, "a");
  cqrImgObj = findParentNode(event.originalTarget, "img");
  if (cqrImgObj){
    cqrImgURL = cqrAbsURI(cqrImgObj.baseURI, cqrImgObj.src);
    cqrImgName = getFNameFromURI(cqrImgURL);
  } else {
    cqrImgURL = "";
    cqrImgName = "";
  }
  if (!cqrLinkURL) {cqrLinkURL = ""}
  
  var kShift = "";
  if (event.shiftKey || event.ctrlKey ){kShift = "yes"}
  
  prfs_LoadMain();
  if ((kShift) && (cqrUseHotMenu)){
    //var box = getBrowser().boxObject;
    var box = browser.boxObject;
    MouseX = event.screenX - box.screenX + box.x;
    MouseY = event.screenY - box.screenY + box.y;

    document.popupNode = event.target;
    event.preventDefault();
    hotmenu(kShift, MouseX, MouseY);
  } else {
    //FillMenu(kShift)
    FillMainMenu();
  }
}

function hotmenu(kShift, x, y){
try{
  var hotmenu = window.document.getElementById("cq-hotmenu");
  if (!hotmenu) {
    hotmenu = window.document.createElement("menupopup");
    hotmenu.id = "cq-hotmenu";
    window.document.documentElement.appendChild(hotmenu);
  }
  hotmenu.setAttribute("position", "at_pointer"); //at_pointer
  FillMenu(kShift, "");
  hotmenu.showPopup(browser, x, y, "context", "", "");
}catch(er){cqerr(er, "hotmenu sub")}
}

function FillMainMenu(){
try{
  var doc = window.document;
  var dataUpdated = false;
  if (cqrMailFlag) {
    var bContextMenu = doc.getElementById("messagePaneContext");
  } else {
    var bContextMenu = doc.getElementById("contentAreaContextMenu");
  }
  var cqmenu = doc.getElementById("cq-menu");
  cqmenu.hidden = cqrHideQueryTo;
  var entriesTrash = [];
  for (i=0; i < bContextMenu.childNodes.length; i++){
    if (bContextMenu.childNodes[i].getAttribute("conquery_flag")!=""){
      entriesTrash.push(bContextMenu.childNodes[i]);
    }
  }
  for (each in entriesTrash) bContextMenu.removeChild(entriesTrash[each]);
  
  if (cqrMainContextLimit > 0){
    bContextMenu.insertBefore(crtSeparator(doc), cqmenu);
    lastDirState = rdir(cqrPlugsDir);
    if (srcDirChanged()) {
    	updated = "true";
    	plg_QuickLoadAll();
    } else {
      prfs_UpdateEntries();
    }
    getPageParams();  
    dataUpdated = true;
    
    var entries = EntryHash.mainSet(cqrMainContextLimit);
    for (id in entries){
      cmEntry = entries[id];
  	  bContextMenu.insertBefore(crtMenuItem(doc, cmEntry, "mainSet"), cqmenu);
  	}
  }

  if (!cqrShowCSPInMainMenu) return;
  
  if (!dataUpdated){
    lastDirState = rdir(cqrPlugsDir);
    if (srcDirChanged()) {
    	updated = "true";
    	plg_QuickLoadAll();
    }
    getPageParams();  
    prfs_UpdateEntries();
  }

  var res = new Object;
//  var first_add = true;
  entries = EntryHash.showifSet();
  for (entry in entries){
    trg = SubstVars(entries[entry].sitarget, entries[entry]);
    cqrShowAlternatives=false;
    res = entries[entry].si_compiled.exec(trg);
    entries[entry].si_compiled.lastIndex=0;
    if (res){
//      if (first_add) {
//        bContextMenu.insertBefore(crtSeparator(doc), cqmenu);
//        first_add = false;
//      } 
      EntryHash.Items[entry].lastmatch = res;
      //dump("Matched values for " + EntryHash.Items[entry].Title + ":\n");
      //for (each in res)dump(each + ": " + res[each] + "\n");
	    bContextMenu.insertBefore(crtMenuItem(doc, entries[entry], "showifSet"), cqmenu);
    } else {
      EntryHash.Items[entries[entry].eId].lastmatch = [];
      EntryHash.Items[entries[entry].eId].lastmatch[0] = trg;
    }
	}
}catch(er){cqerr(er, "FillMainMenu sub")}
}

function FillMenu(kShift, allshowif){
try{
  var doc = window.document;
  var updated = false;
  var recommend = [];

  prfs_LoadMain();
  lastDirState = rdir(cqrPlugsDir);
  if (srcDirChanged()) {
  	updated = "true";
  	plg_QuickLoadAll();
  }
  
  getPageParams();  
  prfs_UpdateEntries();

  if ((kShift) && (cqrUseHotMenu)) {
    var ppMenu = doc.getElementById("cq-hotmenu");
    var entries = EntryHash.conquerySet(0);
    var forceCSPShowInMain = true;
  } else {
    var ppMenu = doc.getElementById("cq-ppm");
    var entries = EntryHash.conquerySet(cqrMainContextLimit);
    var forceCSPShowInMain = false;
  }

  while (ppMenu.hasChildNodes()) {ppMenu.removeChild(ppMenu.lastChild)}
  for (entry in entries) ppMenu.appendChild(crtMenuItem(doc, entries[entry], "conquerySet"));

  if (!cqrShowCSPInMainMenu || forceCSPShowInMain){
    var res = new Object;
//    var first_add = true;
    entries = EntryHash.showifSet();
    for (entry in entries){
      trg = SubstVars(entries[entry].sitarget, entries[entry]);
      cqrShowAlternatives=false;
      res = entries[entry].si_compiled.exec(trg);
      entries[entry].si_compiled.lastIndex=0;
      if (res || allshowif){
//        if (first_add) {
//          ppMenu.appendChild(crtSeparator(doc));
//          first_add = false;
//        } 
        EntryHash.Items[entry].lastmatch = res;
        //dump("Matched values for " + EntryHash.Items[entry].Title + ":\n");
        //for (each in res)dump(each + ": " + res[each] + "\n");
  	    ppMenu.appendChild(crtMenuItem(doc, entries[entry], "showifSet"))
      } else {
        EntryHash.Items[entries[entry].eId].lastmatch = [];
        EntryHash.Items[entries[entry].eId].lastmatch[0] = trg;
      }
  	}
  }

lastDirState = null;
ppMenu = null;
ppItem = null;
entries = null;
}catch(er){cqerr(er, "FillMenu")}
}

function crtSeparator(doc){
    retItem = doc.createElement("menuseparator");
    retItem.setAttribute("conquery_flag", "conquery");
    return retItem;
}

function crtMenuItem(doc, entry, flag){
  var retItem = doc.createElement("menuitem");
  retItem.setAttribute("class", "menuitem-iconic");
    if (!entry.iconpath){
      if (cqrHTTPIcon){
          icourl = url2host(entry.Action);
          if (icourl) {retItem.setAttribute("image", icourl + "/favicon.ico")};
      }
    }else{
      retItem.setAttribute("image", "file://" + entry.iconpath);
    }
  retItem.setAttribute("label", entry.Title);
  retItem.setAttribute("tooltiptext", cqrMess.GetStringFromName('cqr.menu.plgToolTip'));
  retItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entry.eId+"')");
  retItem.setAttribute("conquery_flag", flag);
  return retItem;
}

function detecttrg(evnt){
 if (evnt.originalTarget.localName == "menuseparator") FillMenu(false,true);
}

function ProcessEntry(ctrl, EntryId){
	//getPageParams();
	var entry = EntryHash._Item(EntryId);
	if (ctrl) cqrShowAlternatives = true;
	//if plugin not loaded - load it
	if (!entry.Inputs){
		entry = plg_ReadData(entry.filepath);
    entry.Context = EntryHash.Items[EntryId].Context;
    entry.lastmatch = EntryHash.Items[EntryId].lastmatch;
		EntryHash._AddEntryObj(entry, entry.eId);
	}
  PrepareAction(entry);
	if (cqrcancel){
		resetenv();
		return;
	}

  if (cqrMailFlag){
    //doc = window.document;
    try{
      if (entry.Action){
        var cqrurl = cqrAction;
      } else {
        var cqrurl = entry.Action;
      }
      firstpass = true;
      for (each in QueryHash){
          if (firstpass){
            cqrurl = cqrurl + "?" + each + "=" + QueryHash[each];
            firstpass = false;
          } else {
            cqrurl = cqrurl + "&" + each + "=" + QueryHash[each];
          }
      }
      var mess = Components.classes["@mozilla.org/messenger;1"].getService(Components.interfaces.nsIMessenger);
      mess.launchExternalURL(encodeURI(cqrurl));
      resetenv();
      return;
    }catch(er){cqerr(er, "ProcessEntry sub (mail)")}
  }


  //var browser = getBrowser();
  if ((cqrAction) && (!entry.Inputs)){
    if (cqrOpenRes != "win_fg") {
        tab = browser.addTab(cqrAction);
        if (cqrOpenRes == "tab_fg") browser.selectedTab = tab;
     } else {
        window.open(cqrAction);
     }
     resetenv();
     return;
  }

  if ((cqrOpenRes == "win_fg") || (cqrOpenRes == "win_bg")) {
      myTabRef = window.open();
      if (cqrOpenRes == "win_bg") window.focus();
   } else {
      myTabRef = browser.addTab();
      if (cqrOpenRes == "tab_fg") browser.selectedTab = myTabRef;
   }
  window.setTimeout('formIt("'+ EntryId + '");', 70);
}

function formIt(EntryId){
var entry = EntryHash._Item(EntryId);
    if ((cqrOpenRes == "win_fg") || (cqrOpenRes == "win_bg")) {
        doc = myTabRef.document;
    } else {
        tabBr = getBrowser().getBrowserForTab(myTabRef);
        doc = tabBr.contentDocument;
    }

    try{
      var sbmt = null;
      var frm = doc.createElementNS("http://www.w3.org/1999/xhtml", "form");
      frm.setAttribute("name", "cqrform");
      if (entry.Action){
        frm.setAttribute("action", cqrAction);
      } else {
        frm.setAttribute("action", entry.Action);
      }
      frm.setAttribute("method", entry.Method);
      frm.setAttribute("style", "display: none;");
      frm.setAttribute("accept-charset", entry.qcharset);
      if (cqrMailFlag) frm.setAttribute("target", "_blank");
      for (each in QueryHash){
          // we should be aware of <input name="submit"> :))
          if (each == "submit"){
              sbmt = doc.createElementNS("http://www.w3.org/1999/xhtml", "input");
              sbmt.setAttribute("type", "submit");
              sbmt.setAttribute("name", each);
              sbmt.setAttribute("value", QueryHash[each]);
              frm.appendChild(sbmt);
              continue;
          }
          var inp = doc.createElementNS("http://www.w3.org/1999/xhtml", "input");
          inp.setAttribute("type", "hidden");
          inp.setAttribute("name", each);
          inp.setAttribute("value", QueryHash[each]);
          frm.appendChild(inp);
      }
      doc.documentElement.appendChild(frm);
      if (sbmt!=null){
          frm.submit.click();
      } else {
          frm.submit();
      }
    } catch(er){cqerr(er, "formIt sub")}
    resetenv();    
}

function PrepareAction(EntryObj){
try{
  cqrAction = SubstVars(EntryObj.Action, EntryObj);
  for (i in EntryObj.Inputs){
    QueryHash[EntryObj.Inputs[i].def.name] = SubstVars(EntryObj.Inputs[i].def.value, EntryObj);
  }
  if (cqrShowAlternatives) window.openDialog("chrome://conquery/content/list.xul","_blank", "centerscreen,chrome,modal,resizable=yes", EntryObj);
}catch(er){cqerr(er, "PrepareAction sub")}
}

function SubstVars(str, EntryObj){
    var retstr = "";
    //ire = new RegExp("\\[:(\\w+)(:(\\d*))?\\]", "ig");
    cqrvars = cqrSIRe.exec(str);
    //si_target = EntryObj.sitarget;
    lastind = 0;
    if (cqrvars){
      while (cqrvars){
        tmpstr = str.substring(lastind, cqrSIRe.lastIndex);
        switch("[:"+cqrvars[1]+"]"){
          case "[:selection]":
            if (!cqrPageSelection) cqrShowAlternatives=true;
            retstr += tmpstr.replace("[:selection]", cqrPageSelection);
            break;
          case "[:url]":
            retstr += tmpstr.replace("[:url]", cqrPageURL);
            break;
          case "[:linkurl]":
            retstr += tmpstr.replace("[:linkurl]", cqrLinkURL);
            break;
          case "[:imgurl]":
            retstr += tmpstr.replace("[:imgurl]", cqrImgURL);
            break;
          case "[:imgname]":
            retstr += tmpstr.replace("[:imgname]", cqrImgName);
            break;
          case "[:host]":
            retstr += tmpstr.replace("[:host]", cqrPageHost);
            break;
          case "[:title]":
            retstr += tmpstr.replace("[:title]", cqrPageTitle);
            break;
          case "[:text]":
            retstr += tmpstr.replace("[:text]", "");
            break;
          case "[:matched]":
            var matchnum = Number(cqrvars[3]);
            if (isNaN(matchnum)) matchnum = 0;
            if (EntryObj.lastmatch[matchnum]){
              retstr += tmpstr.replace(cqrvars[0], EntryObj.lastmatch[matchnum]);
            }else{
              retstr += tmpstr.replace(cqrvars[0], "");
            }
            break;
          case "[:prompt]":
            cqrShowAlternatives=true;
            retstr += tmpstr.replace("[:prompt]", "");
            break;
          //if variable is not recognized
          default:
            retstr += tmpstr;
        }
      //ire.lastIndex = 0;
      lastind = cqrSIRe.lastIndex;
      cqrvars = cqrSIRe.exec(str);
      }
      retstr += str.substring(lastind);
    } else {retstr = str}
    return retstr;
}

function processRe(){

}

function OpenCfgDialog(){
	window.openDialog("chrome://conquery/content/conquery-pref.xul", cqrMess.GetStringFromName('cqr.cfg.wTitle'), "centerscreen,chrome,modal,resizable=yes");
  if (cqrConfigLastWillId){
    ProcessEntry(cqrConfigLastWillCtrl, cqrConfigLastWillId);
    cqrConfigLastWillId = "";
  }
}

function getPageParams(){
	try{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		cqrPageSelection = String(focusedWindow.__proto__.getSelection.call(focusedWindow));
	}catch(er){cqrPageSelection=""}
  
  try{
  	cqrPageURL = focusedWindow.location.href;
	}catch(er){cqrPageURL=""}
	
	try{
	  	cqrPageHost = focusedWindow.location.host;
	}catch(er){cqrPageHost=""}

	try{
	  	cqrPageTitle = focusedWindow.document.title;
	}catch(er){cqrPageTitle=""}
}

function resetenv(){
	QueryHash = new Object();
	cqrPageSelection = "";
	cqrPageURL = "";
	cqrPageHost = "";
	cqrLinkURL = "";
	cqrImgName = "";
	cqrImgURL = "";
	cqrPageTitle = "";
	cqrAction = "";
	cqrConfigLastWillId = "";
	cqrConfigLastWillCtrl = false;
	cqrShowAlternatives = false;
	cqrcancel = false;
	cqrTabRef = "";
	cqrWndRef = "";
}
